Index: /trunk/src/VBox/ValidationKit/testmanager/htdocs/css/common.css
===================================================================
--- /trunk/src/VBox/ValidationKit/testmanager/htdocs/css/common.css	(revision 65009)
+++ /trunk/src/VBox/ValidationKit/testmanager/htdocs/css/common.css	(revision 65010)
@@ -102,17 +102,40 @@
  */
 
+html, body {
+    height:         100%;
+}
+
+#wrap {
+    position:       relative;
+    width:          100%;
+    height:         100%;
+}
+
+#head-wrap {
+    position:       fixed;
+    top:            0;
+    left:           0;
+    height:         74px; /**< header + top-menu. */
+    width:          100%;
+    background:     #f9f9f9;
+}
+
 #logo {
-    position:       fixed;
-    width:          100%;
-    height:         92px;
+    width:          42px;
+    height:         46px;
     top:            0;
     left:           0;
     right:          0;
     bottom:         auto;
+    /* Center the image in both directions. */
+    display:        flex;
+    align-items:    center;
+    justify-content: center;
+    justify-content: flex-end;
 }
 
 #logo img {
-    height:         64px;
-    width:          64px;
+    height:         36px;
+    width:          36px;
 }
 
@@ -120,9 +143,15 @@
     position:       fixed;
     width:          100%;  /** @todo this is too wide, darn! */
-    height:         92px;
+    height:         46px;
+    left:           42px;
     top:            0;
-    left:           118px;
     right:          0;
     bottom:         auto;
+    margin-top:     0px;
+    margin-left:    0px;
+    text-align:     left;
+    /* Center the h1 child vertically: */
+    display:        flex;
+    align-items:    center;
 }
 
@@ -131,6 +160,18 @@
     top:            0;
     left:           auto;
-    right:          0;
-    right:          10px;
+    right:          2px;
+    bottom:         auto;
+    height:         auto;
+}
+
+#top-menu {
+    position:       fixed;
+    padding:        0px;
+    width:          99%;
+    height:         auto;
+    max-height:     22px;
+    top:            46px;
+    left:           0px;
+    right:          0px;
     bottom:         auto;
 }
@@ -140,5 +181,5 @@
     width:          116px;
     height:         auto;
-    top:            92px;
+    top:            46px;
     left:           0;
     right:          auto;
@@ -146,41 +187,31 @@
 }
 
-#top-menu {
-    position:       fixed;
-    width:          auto;
-    height:         auto;
-    max-height:     28px;
-    top:            92px;
-    left:           0px;
-    right:          0;
-    bottom:         auto;
-}
-
 #main {
-    position:       fixed;
-    width:          auto;
-    height:         auto;
-    top:            124px;  /**< header + top-menu + padding. */
-    right:          0;
-    bottom:         0;
-    left:           124px;
-    overflow:       auto;
-    padding-top:    16px;
-    padding-left:   10px;
-    padding-right:  10px;
-}
-
-
-/*
- * Header and logo.
- */
-#logo {
-    padding:        16px 32px 16px 32px;
-}
-
-#header {
-    margin-top:     22px;
-    margin-left:    10px;
-    text-align:     left;
+    height:         100%;
+    margin-top:     74px;  /**< header + top-menu + padding. */
+    margin-left:    124px;
+/*    overflow:       auto;*/
+    padding-left:   2px;
+    padding-right:  2px;
+    padding-top:    2px;
+    padding-bottom: 2px;
+}
+
+
+/*
+ * Header and logo specifics.
+ */
+#header h1 {
+    margin-left:    8px;
+    margin-top:     0px;
+    margin-right:   0px;
+    margin-bottom:  0px;
+    font-weight:    bold;
+    font-size:      2.2em;
+    font-family:    Times New, Times, serif;
+}
+
+#login p {
+    line-height:    100%;
 }
 
@@ -303,6 +334,4 @@
 #top-menu {
    margin:          0 auto;
-   margin-right:    10px;
-   margin-left:     10px;
 }
 
Index: /trunk/src/VBox/ValidationKit/testmanager/htdocs/css/details.css
===================================================================
--- /trunk/src/VBox/ValidationKit/testmanager/htdocs/css/details.css	(revision 65009)
+++ /trunk/src/VBox/ValidationKit/testmanager/htdocs/css/details.css	(revision 65010)
@@ -35,4 +35,7 @@
     left:           0;
 }
+#main {
+    margin-left:    0px;
+}
 
 .tmtbl-events {
Index: /trunk/src/VBox/ValidationKit/testmanager/webui/template-details.html
===================================================================
--- /trunk/src/VBox/ValidationKit/testmanager/webui/template-details.html	(revision 65009)
+++ /trunk/src/VBox/ValidationKit/testmanager/webui/template-details.html	(revision 65010)
@@ -13,34 +13,33 @@
 </head>
 
-<body>
+    <body>
+    <div id="wrap">
+        <div id="head-wrap">
+            <div id="logo">
+                <img alt ="VirtualBox" src="htdocs/images/VirtualBox.svg">
+            </div>
+            <div id="header">
+                <h1>@@PAGE_TITLE@@</h1>
+            </div>
+            <div id="top-menu">
+                <ul>
+                    @@TOP_MENU_ITEMS@@
+                </ul>
+            </div>
+            <div id="login">
+                <p><small>
+                    Logged in as <b>@@USER_NAME@@</b>@@LOG_OUT@@
+                </small></p>
+            </div>
+        </div>
 
-<div id="logo">
-    <img alt ="VirtualBox" src="htdocs/images/VirtualBox.svg">
-</div>
+        <div id="main">
+            @@PAGE_BODY@@
 
-<div id="header">
-    <h1>@@PAGE_TITLE@@</h1>
-</div>
+            @@DEBUG@@
+        </div>
 
-<div id="login">
-    <p><small>
-        Logged in as <b>@@USER_NAME@@</b>@@LOG_OUT@@
-    </small></p>
-</div>
-
-<div id="top-menu">
-    <ul>
-        @@TOP_MENU_ITEMS@@
-    </ul>
-</div>
-
-<div id="main" tabindex="1">
-    @@PAGE_BODY@@
-
-    @@DEBUG@@
-</div>
-
-
-</body>
+    </div>
+    </body>
 </html>
 
Index: /trunk/src/VBox/ValidationKit/testmanager/webui/template.html
===================================================================
--- /trunk/src/VBox/ValidationKit/testmanager/webui/template.html	(revision 65009)
+++ /trunk/src/VBox/ValidationKit/testmanager/webui/template.html	(revision 65010)
@@ -1,61 +1,59 @@
 <!DOCTYPE HTML>
 <html lang="en">
-<head>
-    <meta http-equiv="content-type"             content="text/html; charset=UTF-8" />
-    <meta http-equiv="content-language"         content="en" />
-    <meta name="language"                       content="en" />
-    <link href="htdocs/images/tmfavicon.ico"    rel="shortcut icon" />
-    <link href="htdocs/images/tmfavicon.ico"    rel="icon"          type="image/x-icon" />
-    <link href="htdocs/css/common.css"          rel="stylesheet"    type="text/css" media="screen" />
-    <script type="text/javascript" src="htdocs/js/common.js"></script>
-    <title>@@PAGE_TITLE@@</title>
-</head>
+    <head>
+        <meta http-equiv="content-type"             content="text/html; charset=UTF-8" />
+        <meta http-equiv="content-language"         content="en" />
+        <meta name="language"                       content="en" />
+        <link href="htdocs/images/tmfavicon.ico"    rel="shortcut icon" />
+        <link href="htdocs/images/tmfavicon.ico"    rel="icon"          type="image/x-icon" />
+        <link href="htdocs/css/common.css"          rel="stylesheet"    type="text/css" media="screen" />
+        <script type="text/javascript" src="htdocs/js/common.js"></script>
+        <title>@@PAGE_TITLE@@</title>
+    </head>
 
-<body>
+    <body>
+        <div id="wrap">
+            <div id="head-wrap">
+                <div id="logo">
+                    <img alt ="VirtualBox" src="htdocs/images/VirtualBox.svg">
+                </div>
+                <div id="header">
+                    <h1>@@PAGE_TITLE@@</h1>
+                </div>
+                <div id="login">
+                    <p><small>
+                        Logged in as <b>@@USER_NAME@@</b>@@LOG_OUT@@
+                    </small></p>
+                </div>
+                <div id="top-menu">
+                    <ul>
+                        @@TOP_MENU_ITEMS@@
+                    </ul>
+                </div>
+            </div>
 
-<div id="logo">
-    <img alt ="VirtualBox" src="htdocs/images/VirtualBox.svg">
-</div>
+            <div id="side-menu">
+                <form id="side-menu-form">
+                    <ul>
+                        @@SIDE_MENU_ITEMS@@
+                    </ul>
+                    @@SIDE_FILTER_CONTROL@@
+                </form>
+                <div id="side-footer">
+                    <p>
+                    VBox Test Manager<br/>@@TESTMANAGER_VERSION@@r@@TESTMANAGER_REVISION@@
+                    </p>
+                    <br>
+                    <p>Copyright &copy; 2012-2017 Oracle Corporation</p>
+                </div>
+            </div>
 
-<div id="header">
-    <h1>@@PAGE_TITLE@@</h1>
-</div>
+            <div id="main">
+                @@PAGE_BODY@@
 
-<div id="login">
-    <p><small>
-        Logged in as <b>@@USER_NAME@@</b>@@LOG_OUT@@
-    </small></p>
-</div>
-
-<div id="side-menu">
-    <form id="side-menu-form">
-        <ul>
-            @@SIDE_MENU_ITEMS@@
-        </ul>
-        @@SIDE_FILTER_CONTROL@@
-    </form>
-    <div id="side-footer">
-        <p>
-        VBox Test Manager<br/>@@TESTMANAGER_VERSION@@r@@TESTMANAGER_REVISION@@
-        </p>
-        <br>
-        <p>Copyright &copy; 2012-2016 Oracle Corporation</p>
-    </div>
-</div>
-
-<div id="top-menu">
-    <ul>
-        @@TOP_MENU_ITEMS@@
-    </ul>
-</div>
-
-<div id="main" tabindex="1">
-    @@PAGE_BODY@@
-
-    @@DEBUG@@
-</div>
-
-
-</body>
+                @@DEBUG@@
+            </div>
+        </div>
+    </body>
 </html>
 