Index: trunk/src/VBox/Main/include/USBProxyBackend.h
===================================================================
--- trunk/src/VBox/Main/include/USBProxyBackend.h	(revision 65062)
+++ trunk/src/VBox/Main/include/USBProxyBackend.h	(revision 65063)
@@ -225,5 +225,5 @@
     /** The root of usbfs. */
     Utf8Str mDevicesRoot;
-    /** Whether we're using <mUsbfsRoot>/devices or /sys/whatever. */
+    /** Whether we're using \<mUsbfsRoot\>/devices or /sys/whatever. */
     bool mUsingUsbfsDevices;
     /** Number of 500ms polls left to do. See usbDeterminState for details. */
Index: trunk/src/VBox/Main/src-server/AudioAdapterImpl.cpp
===================================================================
--- trunk/src/VBox/Main/src-server/AudioAdapterImpl.cpp	(revision 65062)
+++ trunk/src/VBox/Main/src-server/AudioAdapterImpl.cpp	(revision 65063)
@@ -468,5 +468,5 @@
  *  May be called once right after this object creation.
  *
- *  @param aMachineNode <Machine> node.
+ *  @param data Configuration settings.
  *
  *  @note Locks this object for writing.
@@ -497,5 +497,5 @@
  *  Saves settings to the given machine node.
  *
- *  @param aMachineNode <Machine> node.
+ *  @param data Configuration settings.
  *
  *  @note Locks this object for reading.
Index: trunk/src/VBox/Main/src-server/BIOSSettingsImpl.cpp
===================================================================
--- trunk/src/VBox/Main/src-server/BIOSSettingsImpl.cpp	(revision 65062)
+++ trunk/src/VBox/Main/src-server/BIOSSettingsImpl.cpp	(revision 65063)
@@ -494,5 +494,5 @@
  *  May be called once right after this object creation.
  *
- *  @param aMachineNode <Machine> node.
+ *  @param data Configuration settings.
  *
  *  @note Locks this object for writing.
@@ -514,5 +514,5 @@
  *  Saves settings to the given machine node.
  *
- *  @param aMachineNode <Machine> node.
+ *  @param data Configuration settings.
  *
  *  @note Locks this object for reading.
Index: trunk/src/VBox/Main/src-server/MachineImpl.cpp
===================================================================
--- trunk/src/VBox/Main/src-server/MachineImpl.cpp	(revision 65062)
+++ trunk/src/VBox/Main/src-server/MachineImpl.cpp	(revision 65063)
@@ -8812,5 +8812,5 @@
  *  Recursively loads all snapshots starting from the given.
  *
- *  @param aNode            <Snapshot> node.
+ *  @param data             snapshot settings.
  *  @param aCurSnapshotId   Current snapshot ID from the settings file.
  *  @param aParentSnapshot  Parent snapshot.
@@ -9240,7 +9240,8 @@
  *  Called from i_loadMachineDataFromSettings() for the storage controller data, including media.
  *
- * @param data
- * @param puuidRegistry media registry ID to set media to or NULL; see Machine::i_loadMachineDataFromSettings()
- * @param puuidSnapshot
+ * @param data          storage settings.
+ * @param puuidRegistry media registry ID to set media to or NULL;
+ *                      see Machine::i_loadMachineDataFromSettings()
+ * @param puuidSnapshot snapshot ID
  * @return
  */
@@ -10507,5 +10508,5 @@
  *  Saves the storage controller configuration.
  *
- *  @param aNode    <StorageControllers> node to save the VM hardware configuration to.
+ *  @param data    storage settings.
  */
 HRESULT Machine::i_saveStorageControllers(settings::Storage &data)
Index: trunk/src/VBox/Main/src-server/NetworkAdapterImpl.cpp
===================================================================
--- trunk/src/VBox/Main/src-server/NetworkAdapterImpl.cpp	(revision 65062)
+++ trunk/src/VBox/Main/src-server/NetworkAdapterImpl.cpp	(revision 65063)
@@ -1015,5 +1015,6 @@
  *  May be called once right after this object creation.
  *
- *  @param aAdapterNode <Adapter> node.
+ *  @param bwctl bandwidth control object.
+ *  @param data  Configuration settings.
  *
  *  @note Locks this object for writing.
@@ -1071,5 +1072,5 @@
  *  Note that the given Adapter node is completely empty on input.
  *
- *  @param aAdapterNode <Adapter> node.
+ *  @param data Configuration settings.
  *
  *  @note Locks this object for reading.
Index: trunk/src/VBox/Main/src-server/ParallelPortImpl.cpp
===================================================================
--- trunk/src/VBox/Main/src-server/ParallelPortImpl.cpp	(revision 65062)
+++ trunk/src/VBox/Main/src-server/ParallelPortImpl.cpp	(revision 65063)
@@ -371,5 +371,5 @@
  *  May be called once right after this object creation.
  *
- *  @param aPortNode <Port> node.
+ *  @param data Configuration settings.
  *
  *  @note Locks this object for writing.
@@ -393,5 +393,5 @@
  *  Note that the given Port node is completely empty on input.
  *
- *  @param  <data> node.
+ *  @param  data Configuration settings.
  *
  *  @note Locks this object for reading.
Index: trunk/src/VBox/Main/src-server/SerialPortImpl.cpp
===================================================================
--- trunk/src/VBox/Main/src-server/SerialPortImpl.cpp	(revision 65062)
+++ trunk/src/VBox/Main/src-server/SerialPortImpl.cpp	(revision 65063)
@@ -493,5 +493,5 @@
  *  May be called once right after this object creation.
  *
- *  @param aPortNode <Port> node.
+ *  @param data Configuration settings.
  *
  *  @note Locks this object for writing.
@@ -516,5 +516,5 @@
  *  Note that the given Port node is completely empty on input.
  *
- *  @param aPortNode <Port> node.
+ *  @param data Configuration settings.
  *
  *  @note Locks this object for reading.
Index: trunk/src/VBox/Main/src-server/SnapshotImpl.cpp
===================================================================
--- trunk/src/VBox/Main/src-server/SnapshotImpl.cpp	(revision 65062)
+++ trunk/src/VBox/Main/src-server/SnapshotImpl.cpp	(revision 65063)
@@ -1110,7 +1110,8 @@
  *  Initializes the SnapshotMachine object when loading from the settings file.
  *
- *  @param aMachine machine the snapshot belongs to
- *  @param aHWNode          <Hardware> node
- *  @param aHDAsNode        <HardDiskAttachments> node
+ *  @param aMachine         machine the snapshot belongs to
+ *  @param hardware         hardware settings
+ *  @param pDbg             debuging settings
+ *  @param pAutoStart       autostart settings
  *  @param aSnapshotId      snapshot ID of this snapshot machine
  *  @param aStateFilePath   file where the execution state is saved
Index: trunk/src/VBox/Main/src-server/USBDeviceFiltersImpl.cpp
===================================================================
--- trunk/src/VBox/Main/src-server/USBDeviceFiltersImpl.cpp	(revision 65062)
+++ trunk/src/VBox/Main/src-server/USBDeviceFiltersImpl.cpp	(revision 65063)
@@ -480,5 +480,5 @@
  *  May be called once right after this object creation.
  *
- *  @param aMachineNode <Machine> node.
+ *  @param data Configuration settings.
  *
  *  @note Does not lock "this" as Machine::loadHardware, which calls this, does not lock either.
@@ -523,5 +523,5 @@
  *  Saves settings to the given machine node.
  *
- *  @param aMachineNode <Machine> node.
+ *  @param data Configuration settings.
  *
  *  @note Locks this object for reading.
Index: trunk/src/VBox/Main/src-server/VRDEServerImpl.cpp
===================================================================
--- trunk/src/VBox/Main/src-server/VRDEServerImpl.cpp	(revision 65062)
+++ trunk/src/VBox/Main/src-server/VRDEServerImpl.cpp	(revision 65063)
@@ -188,5 +188,5 @@
  *  May be called once right after this object creation.
  *
- *  @param aMachineNode <Machine> node.
+ *  @param data Configuration settings.
  *
  *  @note Locks this object for writing.
@@ -208,5 +208,5 @@
  *  Saves settings to the given machine node.
  *
- *  @param aMachineNode <Machine> node.
+ *  @param data Configuration settings.
  *
  *  @note Locks this object for reading.