Index: trunk/src/VBox/Main/src-server/ApplianceImpl.cpp
===================================================================
--- trunk/src/VBox/Main/src-server/ApplianceImpl.cpp	(revision 65066)
+++ trunk/src/VBox/Main/src-server/ApplianceImpl.cpp	(revision 65088)
@@ -270,5 +270,5 @@
  * Private helper func that suggests a VirtualBox guest OS type
  * for the given OVF operating system type.
- * @param osTypeVBox
+ * @param strType
  * @param c
  * @param cStr
@@ -446,5 +446,5 @@
 /**
  * Public method implementation.
- * @param
+ * @param   aPath
  * @return
  */
@@ -463,5 +463,5 @@
 /**
  * Public method implementation.
- * @param
+ * @param aDisks
  * @return
  */
@@ -531,5 +531,5 @@
 /**
  * Public method implementation.
- * @param
+ * @param   aVirtualSystemDescriptions
  * @return
  */
@@ -553,5 +553,5 @@
 /**
  * Public method implementation.
- * @param aDisks
+ * @param aMachines
  * @return
  */
@@ -1564,6 +1564,6 @@
  * @param aType Type of description for the new item.
  * @param strRef Reference item; only used with hard disk controllers.
- * @param aOrigValue Corresponding original value from OVF.
- * @param aAutoValue Initial configuration value (can be overridden by caller with setFinalValues).
+ * @param aOvfValue Corresponding original value from OVF.
+ * @param aVBoxValue Initial configuration value (can be overridden by caller with setFinalValues).
  * @param ulSizeMB Weight for IProgress
  * @param strExtraConfig Extra configuration; meaning dependent on type.
Index: trunk/src/VBox/Main/src-server/ApplianceImplImport.cpp
===================================================================
--- trunk/src/VBox/Main/src-server/ApplianceImplImport.cpp	(revision 65066)
+++ trunk/src/VBox/Main/src-server/ApplianceImplImport.cpp	(revision 65088)
@@ -892,4 +892,5 @@
  * Opens a source file (for reading obviously).
  *
+ * @param   stack
  * @param   rstrSrcPath         The source file to open.
  * @param   pszManifestEntry    The manifest entry of the source file.  This is
@@ -993,4 +994,7 @@
 /**
  *
+ * @param   stack               Import stack.
+ * @param   rstrSrcPath         Source path.
+ * @param   rstrDstPath         Destination path.
  * @param   pszManifestEntry    The manifest entry of the source file.  This is
  *                              used when constructing our manifest using a pass
@@ -1041,4 +1045,7 @@
 /**
  *
+ * @param   stack
+ * @param   rstrSrcPath
+ * @param   rstrDstPath
  * @param   pszManifestEntry    The manifest entry of the source file.  This is
  *                              used when constructing our manifest using a pass
@@ -1988,6 +1995,6 @@
  * 1) from the public Appliance::ImportMachines().
  *
- * @param aLocInfo
- * @param aProgress
+ * @param locInfo
+ * @param progress
  * @return
  */
@@ -2364,5 +2371,5 @@
             lControllerPort = (long)ulAddressOnParent;
             lDevice = (long)0;
-        break;
+            break;
 
         case ovf::HardDiskController::SCSI:
@@ -2374,6 +2381,6 @@
             lControllerPort = (long)ulAddressOnParent;
             lDevice = (long)0;
+            break;
         }
-        break;
 
         default: break;
@@ -3448,7 +3455,7 @@
  *  4)  Create the VirtualBox machine with the modfified machine config.
  *
- * @param config
- * @param pNewMachine
- * @param stack
+ * @param   vsdescThis
+ * @param   pReturnNewMachine 
+ * @param   stack
  */
 void Appliance::i_importVBoxMachine(ComObjPtr<VirtualSystemDescription> &vsdescThis,
Index: trunk/src/VBox/Main/src-server/HostDnsService.h
===================================================================
--- trunk/src/VBox/Main/src-server/HostDnsService.h	(revision 65066)
+++ trunk/src/VBox/Main/src-server/HostDnsService.h	(revision 65088)
@@ -116,5 +116,5 @@
 };
 
-# ifdef RT_OS_DARWIN
+# if defined(RT_OS_DARWIN) || defined(DOXYGEN_RUNNING)
 class HostDnsServiceDarwin : public HostDnsMonitor
 {
@@ -135,5 +135,5 @@
 };
 # endif
-# ifdef RT_OS_WINDOWS
+# if defined(RT_OS_WINDOWS) || defined(DOXYGEN_RUNNING)
 class HostDnsServiceWin : public HostDnsMonitor
 {
@@ -155,5 +155,6 @@
 };
 # endif
-# if defined(RT_OS_SOLARIS) || defined(RT_OS_LINUX) || defined(RT_OS_OS2) || defined(RT_OS_FREEBSD)
+# if defined(RT_OS_SOLARIS) || defined(RT_OS_LINUX) || defined(RT_OS_OS2) || defined(RT_OS_FREEBSD) \
+    || defined(DOXYGEN_RUNNING)
 class HostDnsServiceResolvConf: public HostDnsMonitor
 {
@@ -176,5 +177,5 @@
     Data *m;
 };
-#  if defined(RT_OS_SOLARIS)
+#  if defined(RT_OS_SOLARIS) || defined(DOXYGEN_RUNNING)
 /**
  * XXX: https://blogs.oracle.com/praks/entry/file_events_notification
@@ -190,5 +191,6 @@
 };
 
-#  elif defined(RT_OS_LINUX)
+#  endif
+#  if defined(RT_OS_LINUX) || defined(DOXYGEN_RUNNING)
 class HostDnsServiceLinux : public HostDnsServiceResolvConf
 {
@@ -205,5 +207,6 @@
 };
 
-#  elif defined(RT_OS_FREEBSD)
+#  endif
+#  if defined(RT_OS_FREEBSD) || defined(DOXYGEN_RUNNING)
 class HostDnsServiceFreebsd: public HostDnsServiceResolvConf
 {
@@ -216,5 +219,6 @@
 };
 
-#  elif defined(RT_OS_OS2)
+#  endif
+#  if defined(RT_OS_OS2) || defined(DOXYGEN_RUNNING)
 class HostDnsServiceOs2 : public HostDnsServiceResolvConf
 {
Index: trunk/src/VBox/Main/src-server/HostImpl.cpp
===================================================================
--- trunk/src/VBox/Main/src-server/HostImpl.cpp	(revision 65066)
+++ trunk/src/VBox/Main/src-server/HostImpl.cpp	(revision 65088)
@@ -1154,5 +1154,5 @@
  *
  * @returns COM status code
- * @param   os address of result variable
+ * @param   aOperatingSystem result variable
  */
 HRESULT Host::getOperatingSystem(com::Utf8Str &aOperatingSystem)
Index: trunk/src/VBox/Main/src-server/HostNetworkInterfaceImpl.cpp
===================================================================
--- trunk/src/VBox/Main/src-server/HostNetworkInterfaceImpl.cpp	(revision 65066)
+++ trunk/src/VBox/Main/src-server/HostNetworkInterfaceImpl.cpp	(revision 65088)
@@ -66,4 +66,5 @@
  * @param   aInterfaceName name of the network interface
  * @param   aGuid GUID of the host network interface
+ * @param   ifType interface type
  */
 HRESULT HostNetworkInterface::init(Bstr aInterfaceName, Bstr aShortName, Guid aGuid, HostNetworkInterfaceType_T ifType)
@@ -363,8 +364,8 @@
 
 /**
- * Returns the IP V6 network mask of the host network interface.
- *
- * @returns COM status code
- * @param   aIPV6Mask address of result pointer
+ * Returns the IP V6 network mask prefix length of the host network interface.
+ *
+ * @returns COM status code
+ * @param   aIPV6NetworkMaskPrefixLength address of result pointer
  */
 HRESULT HostNetworkInterface::getIPV6NetworkMaskPrefixLength(ULONG *aIPV6NetworkMaskPrefixLength)
Index: trunk/src/VBox/Main/src-server/SnapshotImpl.cpp
===================================================================
--- trunk/src/VBox/Main/src-server/SnapshotImpl.cpp	(revision 65066)
+++ trunk/src/VBox/Main/src-server/SnapshotImpl.cpp	(revision 65088)
@@ -639,6 +639,6 @@
 /**
  * Internal implementation for Snapshot::updateSavedStatePaths (below).
- * @param aOldPath
- * @param aNewPath
+ * @param   strOldPath
+ * @param   strNewPath
  */
 void Snapshot::i_updateSavedStatePathsImpl(const Utf8Str &strOldPath,
@@ -714,11 +714,11 @@
  *  Intended to be called by Machine::openConfigLoader() only.
  *
- *  @param aOldPath old path (full)
- *  @param aNewPath new path (full)
+ *  @param  strOldPath old path (full)
+ *  @param  strNewPath new path (full)
  *
  *  @note Locks the machine (for the snapshots tree) +  this object + children for writing.
  */
 void Snapshot::i_updateSavedStatePaths(const Utf8Str &strOldPath,
-                                      const Utf8Str &strNewPath)
+                                       const Utf8Str &strNewPath)
 {
     LogFlowThisFunc(("aOldPath={%s} aNewPath={%s}\n", strOldPath.c_str(), strNewPath.c_str()));
@@ -1858,5 +1858,8 @@
  * @note Locks VirtualBox and this object for writing.
  *
- * @param aSuccess Whether Console was successful with the client-side snapshot things.
+ * @param   task
+ * @param   alock
+ * @param   aSuccess    Whether Console was successful with the client-side
+ *                      snapshot things.
  * @return
  */
@@ -2617,5 +2620,5 @@
  * @note Locks the machine + the snapshot + the media tree for writing!
  *
- * @param pTask Task data.
+ * @param task Task data.
  */
 void SessionMachine::i_deleteSnapshotHandler(DeleteSnapshotTask &task)
Index: trunk/src/VBox/Main/src-server/USBDeviceFilterImpl.cpp
===================================================================
--- trunk/src/VBox/Main/src-server/USBDeviceFilterImpl.cpp	(revision 65066)
+++ trunk/src/VBox/Main/src-server/USBDeviceFilterImpl.cpp	(revision 65088)
@@ -39,5 +39,5 @@
  *  @param  aFilter     The filter.
  *  @param  aIdx        The field index.
- *  @param  aStr        The output string.
+ *  @param  rstrOut     The output string.
  */
 static void i_usbFilterFieldToString(PCUSBFILTER aFilter, USBFILTERIDX aIdx, Utf8Str &rstrOut)
Index: trunk/src/VBox/Main/src-server/USBProxyBackend.cpp
===================================================================
--- trunk/src/VBox/Main/src-server/USBProxyBackend.cpp	(revision 65066)
+++ trunk/src/VBox/Main/src-server/USBProxyBackend.cpp	(revision 65088)
@@ -559,5 +559,5 @@
  *
  * @returns Pointer to the head of the sorted doubly linked list.
- * @param   aDevices        Head pointer (can be both singly and doubly linked list).
+ * @param   pDevices        Head pointer (can be both singly and doubly linked list).
  */
 static PUSBDEVICE sortDevices(PUSBDEVICE pDevices)
Index: trunk/src/VBox/Main/src-server/USBProxyService.cpp
===================================================================
--- trunk/src/VBox/Main/src-server/USBProxyService.cpp	(revision 65066)
+++ trunk/src/VBox/Main/src-server/USBProxyService.cpp	(revision 65088)
@@ -264,4 +264,5 @@
  * @param   aMachine        The machine to attach the device to.
  * @param   aId             The UUID of the USB device to capture and attach.
+ * @param   aCaptureFilename
  *
  * @returns COM status code and error info.
@@ -423,4 +424,6 @@
  *
  * @param   aMachine        The machine to detach devices from.
+ * @param   aDone
+ * @param   aAbnormal
  *
  * @returns COM status code, perhaps with error info.
Index: trunk/src/VBox/Main/src-server/VirtualBoxImpl.cpp
===================================================================
--- trunk/src/VBox/Main/src-server/VirtualBoxImpl.cpp	(revision 65066)
+++ trunk/src/VBox/Main/src-server/VirtualBoxImpl.cpp	(revision 65088)
@@ -3188,5 +3188,5 @@
  *
  * @param aId Machine UUID to look for.
- * @param aPermitInaccessible If true, inaccessible machines will be found;
+ * @param fPermitInaccessible If true, inaccessible machines will be found;
  *                  if false, this will fail if the given machine is inaccessible.
  * @param aSetError If true, set errorinfo if the machine is not found.
@@ -3349,6 +3349,6 @@
  * Validates a machine group.
  *
- * @param aMachineGroup     Machine group.
- * @param fPrimary          Set if this is the primary group.
+ * @param aGroup    Machine group.
+ * @param fPrimary  Set if this is the primary group.
  *
  * @return S_OK or E_INVALIDARG
@@ -3452,5 +3452,5 @@
  * object that matches either of them (not necessarily both) is returned.
  *
- * @param aLocation     Full location specification. Must not be empty.
+ * @param strLocation   Full location specification. Must not be empty.
  * @param aSetError     If @c true , the appropriate error info is set in case
  *                      when the hard disk is not found.
@@ -3773,5 +3773,5 @@
  * directory as the current directory.
  *
- * @param  aPath    Path to calculate the absolute path for.
+ * @param  strPath  Path to calculate the absolute path for.
  * @param  aResult  Where to put the result (used only on success, can be the
  *                  same Utf8Str instance as passed in @a aPath).
@@ -4823,6 +4823,6 @@
  * directory which is normally unknown.
  *
- * @param aFileName     Full file name which path is checked/created.
- * @param aCreate       Flag if the path should be created if it doesn't exist.
+ * @param strFileName   Full file name which path is checked/created.
+ * @param fCreate       Flag if the path should be created if it doesn't exist.
  *
  * @return Extended error information on failure to check/create the path.
Index: trunk/src/VBox/Main/src-server/darwin/HostDnsServiceDarwin.cpp
===================================================================
--- trunk/src/VBox/Main/src-server/darwin/HostDnsServiceDarwin.cpp	(revision 65066)
+++ trunk/src/VBox/Main/src-server/darwin/HostDnsServiceDarwin.cpp	(revision 65088)
@@ -169,14 +169,14 @@
                                                             kStateNetworkGlobalDNSKey);
     /**
-     * 0:vvl@nb-mbp-i7-2(0)# scutil
-     * > get State:/Network/Global/DNS
-     * > d.show
-     * <dictionary> {
+     * # scutil
+     * \> get State:/Network/Global/DNS
+     * \> d.show
+     * \<dictionary\> {
      * DomainName : vvl-domain
-     * SearchDomains : <array> {
+     * SearchDomains : \<array\> {
      * 0 : vvl-domain
      * 1 : de.vvl-domain.com
      * }
-     * ServerAddresses : <array> {
+     * ServerAddresses : \<array\> {
      * 0 : 192.168.1.4
      * 1 : 192.168.1.1
Index: trunk/src/VBox/Main/src-server/darwin/NetIf-darwin.cpp
===================================================================
--- trunk/src/VBox/Main/src-server/darwin/NetIf-darwin.cpp	(revision 65066)
+++ trunk/src/VBox/Main/src-server/darwin/NetIf-darwin.cpp	(revision 65088)
@@ -540,6 +540,7 @@
  * @param   puMbits     Where to store the link speed.
  */
-int NetIfGetLinkSpeed(const char * /*pcszIfName*/, uint32_t * /*puMbits*/)
-{
+int NetIfGetLinkSpeed(const char *pcszIfName, uint32_t *puMbits)
+{
+    RT_NOREF(pcszIfName, puMbits);
     return VERR_NOT_IMPLEMENTED;
 }
Index: trunk/src/VBox/Main/src-server/linux/HostHardwareLinux.cpp
===================================================================
--- trunk/src/VBox/Main/src-server/linux/HostHardwareLinux.cpp	(revision 65066)
+++ trunk/src/VBox/Main/src-server/linux/HostHardwareLinux.cpp	(revision 65088)
@@ -327,7 +327,7 @@
  * @param pcszModel   the product ID string
  * @param pszDesc    where to store the description string (optional)
- * @param cchDesc    the size of the buffer in @pszDesc
+ * @param cchDesc    the size of the buffer in @a pszDesc
  * @param pszUdi     where to store the UDI string (optional)
- * @param cchUdi     the size of the buffer in @pszUdi
+ * @param cchUdi     the size of the buffer in @a pszUdi
  */
 /* static */
Index: trunk/src/VBox/Main/src-server/os2/USBProxyBackendOs2.cpp
===================================================================
--- trunk/src/VBox/Main/src-server/os2/USBProxyBackendOs2.cpp	(revision 65066)
+++ trunk/src/VBox/Main/src-server/os2/USBProxyBackendOs2.cpp	(revision 65088)
@@ -77,13 +77,13 @@
                 }
 
-                LogRel(("USBProxyServiceOs2: failed to register change notification, rc=%d\n", rc));
+                LogRel(("USBProxyBackendOs2: failed to register change notification, rc=%d\n", rc));
             }
             else
-                LogRel(("USBProxyServiceOs2: failed to load usbcalls\n"));
+                LogRel(("USBProxyBackendOs2: failed to load usbcalls\n"));
 
             DosFreeModule(mhmod);
         }
         else
-            LogRel(("USBProxyServiceOs2: failed to load usbcalls, rc=%d\n", rc));
+            LogRel(("USBProxyBackendOs2: failed to load usbcalls, rc=%d\n", rc));
         mhmod = NULLHANDLE;
     }
@@ -99,5 +99,5 @@
  * Stop all service threads and free the device chain.
  */
-USBProxyServiceOs2::~USBProxyServiceOs2()
+USBProxyBackendOs2::~USBProxyBackendOs2()
 {
     LogFlowThisFunc(("\n"));
@@ -128,5 +128,5 @@
 
 
-int USBProxyServiceOs2::captureDevice(HostUSBDevice *aDevice)
+int USBProxyBackendOs2::captureDevice(HostUSBDevice *aDevice)
 {
     AssertReturn(aDevice, VERR_GENERAL_FAILURE);
@@ -147,5 +147,5 @@
 
 
-int USBProxyServiceOs2::releaseDevice(HostUSBDevice *aDevice)
+int USBProxyBackendOs2::releaseDevice(HostUSBDevice *aDevice)
 {
     AssertReturn(aDevice, VERR_GENERAL_FAILURE);
@@ -166,5 +166,5 @@
 
 
-bool USBProxyServiceOs2::updateDeviceState(HostUSBDevice *aDevice, PUSBDEVICE aUSBDevice, bool *aRunFilters,
+bool USBProxyBackendOs2::updateDeviceState(HostUSBDevice *aDevice, PUSBDEVICE aUSBDevice, bool *aRunFilters,
                                            SessionMachine **aIgnoreMachine)
 {
@@ -176,5 +176,5 @@
 
 
-int USBProxyServiceOs2::wait(RTMSINTERVAL aMillies)
+int USBProxyBackendOs2::wait(RTMSINTERVAL aMillies)
 {
     int rc = DosWaitEventSem(mhev, aMillies);
@@ -183,5 +183,5 @@
 
 
-int USBProxyServiceOs2::interruptWait(void)
+int USBProxyBackendOs2::interruptWait(void)
 {
     int rc = DosPostEventSem(mhev);
@@ -193,5 +193,5 @@
 #include <stdio.h>
 
-PUSBDEVICE USBProxyServiceOs2::getDevices(void)
+PUSBDEVICE USBProxyBackendOs2::getDevices(void)
 {
     /*